# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Defined types

* [`vcsdeploy`](#vcsdeploy): Deploy an application using VCS

## Defined types

### `vcsdeploy`

This defined type will deploy an application that comes from a repository.

At first fetch and on updates, this will run a custom command.

#### Examples

##### 

```puppet
vcsdeploy { '/path/to/application':
  ensure              => latest,
  source              => 'https://gitlab.com/corporation/application',
  after_fetch_command => '/path/to/application/bin/deploy',
}
```

#### Parameters

The following parameters are available in the `vcsdeploy` defined type.

##### `source`

Data type: `String[1]`

The source URI for the repository

##### `after_fetch_command`

Data type: `Stdlib::Absolutepath`

The command to execute after VCS fetch

##### `ensure`

Data type: `Enum[latest, present, absent]`

Ensure the version control repository

Default value: `latest`

##### `target`

Data type: `Stdlib::Absolutepath`

The target path to fetch repository

Default value: `$name`

##### `revision`

Data type: `String[1]`

The revision of the repository

Default value: `'master'`

##### `user`

Data type: `Optional[String[1]]`

The user/uid that owns the repository files and run after fetch command

Default value: ``undef``

##### `group`

Data type: `Optional[String[1]]`

The group/gid that owns the repository files and run after fetch command

Default value: `$user`

##### `vcsrepo_attributes`

Data type: `Hash`

The additionnal attributes passed to `vcsrepo` resource

Default value: `{}`

##### `after_fetch_command_attributes`

Data type: `Hash`

The additionnal attributes passed to `exec` resource

Default value: `{}`

##### `after_fetch_resources`

Data type: `Array[Type[Resource]]`

The resources that need to be realized after a fetch

Default value: `[]`

